import com.nttdocomo.ui.*;

/*
	ukQ[CuDoJa
	Wrbg}bvNX

	2007/10/24 ˁ@P
*/
public class ukBitmap implements ukImage {

	private Image _img;
	private Image _tmp;
	private MediaImage _mimg;

	private ukGraphics _g;

	/**
	* wTCỸrbg}bv쐬
	* @param width 
	* @param height 
	*/
	public ukBitmap(int width, int height) {

		_img = Image.createImage(width, height);

		if (_img != null) {

			_g = new ukGraphics();
			_g.setGraphics(_img.getGraphics());

		} else {
			_g = null;
		}

	}

	/**
	* wTCỸrbg}bv쐬
	* @param width 
	* @param height 
	* @param pixels sNZf[^
	* @param offset z̃sNZf[^擪ʒu
	*/
	public ukBitmap(int width, int height, int[] pixels, int offset) {

		assign(width, height, pixels, offset);

	}

	/**
	* wTCỸrbg}bv쐬
	* @param data 摜f[^
	*/
	public ukBitmap(byte[] data) {

		load(data);

	}

	/**
	* wURĨf[^rbg}bv쐬
	* @param uri 摜f[^̃AhX
	*/
	public ukBitmap(ukURI url) {

		byte[] data = ukNetUtil.getHttpDocument(url.getURI());

		if (data == null || data.length < 1) {
			return;
		}

		load(data);

	}

	/**
	* 摜f[^摜TCYƃsNZ擾
	* @param data 摜f[^
	* @return 擪4oCgA4oCgAȍ~sNZBsnull
	*/
	public static int[] decode(byte[] data) {

		if (data == null) {
			return null;
		}

		if (data.length > 32 && data[0] == 'B' && data[1] == 'M' && data[28] == 24) {
			return decodeBMP(data);
		}

		return null;

	}

	/**
	* BMP`摜f[^摜TCYƃsNZ擾
	* @param data BMP`摜f[^
	* @return 擪4oCgA4oCgAȍ~sNZBsnull
	*/
	private static int[] decodeBMP(byte[] data) {

		if (data == null || data.length < 32 || data[0] != 'B' || data[1] != 'M' || data[28] != 24) {
			return null;
		}

		int offset = data[10] + data[11] * 256;

		int width = (int)(data[18] & 0xff) | ((int)(data[19] & 0xff) << 8) | ((int)(data[20] & 0xff) << 16) | ((int)(data[21] & 0xff) << 24);
		int height = (int)(data[22] & 0xff) | ((int)(data[23] & 0xff) << 8) | ((int)(data[24] & 0xff) << 16) | ((int)(data[25] & 0xff) << 24);

		int length = width * 3;

		if (width % 4 != 0) {
			length = width * 3 + (4 - (width * 3) % 4);
		}

		// sNZz擾
		int[] pixels = new int[2 + width * height];

		pixels[0] = width;
		pixels[1] = height;

		for (int i = 0;i < height;i++) {
			for (int j = 0;j < width;j++) {
				pixels[2 + j + (height - i - 1) * width] = (((int)data[offset + j * 3 + i * length + 2] & 0xff) << 16) | (((int)data[offset + j * 3 + i * length + 1] & 0xff) << 8) | (int)(data[offset + j * 3 + i * length] & 0xff);
			}
		}

		return pixels;

	}

	private boolean load(byte[] data) {

		if (data != null && data.length > 32 && data[0] == 'B' && data[1] == 'M' && data[28] == 24) {
			return loadBMP(data);
		}

		// oCif[^MediaImage쐬
		_mimg = MediaManager.getImage(data);

		// MediaImage𗘗p\Ԃ
		try {
			_mimg.use();
		} catch (Exception e) {}

		// C[W擾
		_img = _mimg.getImage();

		if (_img != null) {

			_g = new ukGraphics();
			_g.setGraphics(_img.getGraphics());

		} else {
			_g = null;
		}

		return true;

	}

	private boolean loadBMP(byte[] data) {

		int[] pixels = decodeBMP(data);

		if (pixels == null || pixels.length < 3) {
			return false;
		}

		assign(pixels[0], pixels[1], pixels, 2);

		return true;

	}

	// RGBz񂩂摜쐬
	private boolean assign(int width, int height, int[] pixels, int offset) {

		if (width < 1 || height < 1 || pixels == null || (pixels.length - offset) < width * height) {
			return false;
		}

		_img = null;
		_g = null;

		_img = Image.createImage(width, height, pixels, offset);

		if (_img == null) {
			return false;
		}

		_g = new ukGraphics(_img.getGraphics());

		return true;

	}

	public int getWidth() {

		if (_img == null) {
			return 0;
		}

		return _img.getWidth();

	}

	public int getHeight() {

		if (_img == null) {
			return 0;
		}

		return _img.getHeight();

	}

	public int getPixelRGB(int x, int y) {

		if (_img == null || x < 0 || x >= getWidth() || y < 0 || y >= getHeight() || _g == null) {
			return 0;
		}

		return _g.getGraphics().getRGBPixel(x, y);

	}

	public int[] getPixelRGB(int[] buf, int offset, int x, int y, int width, int height) {

		if (_img == null || _g == null || x < 0 || x >= getWidth() || y < 0 || y >= getHeight() || x + width > getWidth() || y + height > getHeight() || (buf != null) && (buf.length - offset) < width * height) {
			return null;
		}

		if (buf == null) {
			buf = new int[offset + width * height];
		}

		if (buf == null) {
			return null;
		}

		_g.getGraphics().getRGBPixels(x, y, width, height, buf, offset);

		return buf;

	}

	public Image getImage() {
		return _img;
	}

	public ukGraphics getUkGraphics() {
		return _g;
	}

	// sNZ(x, y)RGBݒ
	public boolean setPixelRGB(int x, int y, int rgb) {

		if (_img == null || x < 0 || x >= getWidth() || y < 0 || y >= getHeight()) {
			return false;
		}

		// GraphicsōXV\ȂGraphicsœ_ł
		if (_g != null) {

			_g.setRGB(rgb);

			_g.drawRect(x, y, 1, 1);

			return true;

		}

		return false;

	}

	// sNZ(x, y)RGBݒ
	public boolean setPixelRGB(int x, int y, int r, int g, int b) {
		return setPixelRGB(x, y, (r << 16) | (g << 8) | b);
	}

	public void movePixels(int dx, int dy) {

		if (_g == null) {
			return;
		}

		int width = getWidth();
		int height = getHeight();

		if (width < 1 || height < 1) {
			return;
		}

		if (_tmp == null) {
			_tmp = Image.createImage(width, height);
		}

		if (_tmp == null) {
			return;
		}

		_tmp.getGraphics().drawImage(_img, 0, 0);

		_g.getGraphics().drawImage(_tmp, dx, dy);

	}

	// SsNZwRGBŃNA
	public void clear(int rgb) {

		if (_img == null) {
			return;
		}

		// GraphicsōXV\ȂGraphicsfillRect
		if (_g != null) {

			_g.setRGB(rgb);

			_g.fillRect(0, 0, _img.getWidth(), _img.getHeight());

			return;

		}

		int width = _img.getWidth();
		int height = _img.getHeight();

		if (width < 1 || height < 1) {
			return;
		}

		int[] argb = new int[width * height];

		for (int i = 0;i < width * height;i++) {
			argb[i] = 0xff000000 | rgb;
		}

		assign(width, height, argb, 0);

	}

	/**
	* gp\[XArbg}bv폜
	*/
	public void release() {

		if (_mimg != null) {

			_mimg.unuse();

			_mimg.dispose();

			_mimg = null;

		}

		_img = null;
		_tmp = null;
		_g = null;

	}

}
