import com.nttdocomo.ui.*;
import java.io.*;

public class ukCanvas extends Canvas {

	public static final int UK_KEY_FLG_NONE = 0;
	public static final int UK_KEY_FLG_NUM0 = 1;
	public static final int UK_KEY_FLG_NUM1 = 1 << 2;
	public static final int UK_KEY_FLG_NUM2 = 1 << 3;
	public static final int UK_KEY_FLG_NUM3 = 1 << 4;
	public static final int UK_KEY_FLG_NUM4 = 1 << 5;
	public static final int UK_KEY_FLG_NUM5 = 1 << 6;
	public static final int UK_KEY_FLG_NUM6 = 1 << 7;
	public static final int UK_KEY_FLG_NUM7 = 1 << 8;
	public static final int UK_KEY_FLG_NUM8 = 1 << 9;
	public static final int UK_KEY_FLG_NUM9 = 1 << 10;
	public static final int UK_KEY_FLG_STAR = 1 << 11;
	public static final int UK_KEY_FLG_POUND = 1 << 12;

	public static final int UK_KEY_FLG_UP = 1 << 16;
	public static final int UK_KEY_FLG_RIGHT = 1 << 17;
	public static final int UK_KEY_FLG_DOWN = 1 << 18;
	public static final int UK_KEY_FLG_LEFT = 1 << 19;
	public static final int UK_KEY_FLG_SELECT = 1 << 20;

	public static final int UK_KEY_FLG_SOFT1 = 1 << 24;
	public static final int UK_KEY_FLG_SOFT2 = 1 << 25;

	public static final int UK_STICK_NONE = 0;
	public static final int UK_STICK_UP = UK_KEY_FLG_UP;
	public static final int UK_STICK_UPRIGHT = UK_KEY_FLG_UP | UK_KEY_FLG_RIGHT;
	public static final int UK_STICK_RIGHT = UK_KEY_FLG_RIGHT;
	public static final int UK_STICK_DOWNRIGHT = UK_KEY_FLG_DOWN | UK_KEY_FLG_RIGHT;
	public static final int UK_STICK_DOWN = UK_KEY_FLG_DOWN;
	public static final int UK_STICK_DOWNLEFT = UK_KEY_FLG_DOWN | UK_KEY_FLG_LEFT;
	public static final int UK_STICK_LEFT = UK_KEY_FLG_LEFT;
	public static final int UK_STICK_UPLEFT = UK_KEY_FLG_UP | UK_KEY_FLG_LEFT;

	public static final int UK_TRIGGER_NONE = 0;
	public static final int UK_TRIGGER_A = 1;
	public static final int UK_TRIGGER_B = 2;

	public static final int UK_COMMAND_SOFT1 = 1;
	public static final int UK_COMMAND_SOFT2 = 2;

	private final int UK_KEYPAD_FLG_0 = 1 << Display.KEY_0;
	private final int UK_KEYPAD_FLG_1 = 1 << Display.KEY_1;
	private final int UK_KEYPAD_FLG_2 = 1 << Display.KEY_2;
	private final int UK_KEYPAD_FLG_3 = 1 << Display.KEY_3;
	private final int UK_KEYPAD_FLG_4 = 1 << Display.KEY_4;
	private final int UK_KEYPAD_FLG_5 = 1 << Display.KEY_5;
	private final int UK_KEYPAD_FLG_6 = 1 << Display.KEY_6;
	private final int UK_KEYPAD_FLG_7 = 1 << Display.KEY_7;
	private final int UK_KEYPAD_FLG_8 = 1 << Display.KEY_8;
	private final int UK_KEYPAD_FLG_9 = 1 << Display.KEY_9;
	private final int UK_KEYPAD_FLG_STAR = 1 << Display.KEY_ASTERISK;
	private final int UK_KEYPAD_FLG_POUND = 1 << Display.KEY_POUND;

	private final int UK_KEYPAD_FLG_SELECT = 1 << Display.KEY_SELECT;

	private final int UK_KEYPAD_FLG_UP = 1 << Display.KEY_UP;
	private final int UK_KEYPAD_FLG_RIGHT = 1 << Display.KEY_RIGHT;
	private final int UK_KEYPAD_FLG_DOWN = 1 << Display.KEY_DOWN;
	private final int UK_KEYPAD_FLG_LEFT = 1 << Display.KEY_LEFT;
	private final int UK_KEYPAD_FLG_TRIG_A = 1 << Display.KEY_SELECT;
	private final int UK_KEYPAD_FLG_TRIG_B = UK_KEYPAD_FLG_3;

	// L[ԃtO
	protected int _keyFlags;

	protected ukGameMain _app;

	private ukGraphics _g;

	public ukCanvas() {

		_g = new ukGraphics();

	}

	public void setSoftKey(int key, String label) {

		switch (key) {

		case 1:

			setSoftLabel(SOFT_KEY_1, label);

			break;

		case 2:

			setSoftLabel(SOFT_KEY_2, label);

			break;

		}

	}

	public void setSoftKey(String soft1, String soft2) {

		setSoftLabel(SOFT_KEY_1, soft1);
		setSoftLabel(SOFT_KEY_2, soft2);

	}

	protected void onCommand(int command) {

	}

	// gK[L[̏Ԏ擾
	protected int getTrigger() {

		int key = getKeypadState();

		int trigger = 0;

		if ((key & UK_KEYPAD_FLG_TRIG_A) != 0) {
			trigger = UK_TRIGGER_A;
		}

		if ((key & UK_KEYPAD_FLG_TRIG_B) != 0) {
			trigger = UK_TRIGGER_B;
		}

		return trigger;

	}

	public int getStick() {

		int key = getKeypadState();

		int flag = UK_STICK_NONE;

		if ((key & UK_KEYPAD_FLG_UP) != 0 || (key & UK_KEYPAD_FLG_2) != 0) {
			flag |= UK_STICK_UP;
		}

		if ((key & UK_KEYPAD_FLG_DOWN) != 0 || (key & UK_KEYPAD_FLG_8) != 0) {
			flag |= UK_STICK_DOWN;
		}

		if ((key & UK_KEYPAD_FLG_LEFT) != 0 || (key & UK_KEYPAD_FLG_4) != 0) {
			flag |= UK_STICK_LEFT;
		}

		if ((key & UK_KEYPAD_FLG_RIGHT) != 0 || (key & UK_KEYPAD_FLG_6) != 0) {
			flag |= UK_STICK_RIGHT;
		}

		return flag;

	}

	public void resetKey() {

		_keyFlags = UK_KEY_FLG_NONE;

	}

	public void processEvent(int type, int param) {

		int key = UK_KEY_FLG_NONE;

		switch(param) {

		case UK_KEYPAD_FLG_0:

			key = UK_KEY_FLG_NUM0;

			break;

		case UK_KEYPAD_FLG_1:

			key = UK_KEY_FLG_NUM1;

			break;

		case UK_KEYPAD_FLG_2:

			key = UK_KEY_FLG_NUM2;

			break;

		case UK_KEYPAD_FLG_3:

			key = UK_KEY_FLG_NUM3;

			break;

		case UK_KEYPAD_FLG_4:

			key = UK_KEY_FLG_NUM4;

			break;

		case UK_KEYPAD_FLG_5:

			key = UK_KEY_FLG_NUM5;

			break;

		case UK_KEYPAD_FLG_6:

			key = UK_KEY_FLG_NUM6;

			break;

		case UK_KEYPAD_FLG_7:

			key = UK_KEY_FLG_NUM7;

			break;

		case UK_KEYPAD_FLG_8:

			key = UK_KEY_FLG_NUM8;

			break;

		case UK_KEYPAD_FLG_9:

			key = UK_KEY_FLG_NUM9;

			break;

		case UK_KEYPAD_FLG_STAR:

			key = UK_KEY_FLG_STAR;

			break;

		case UK_KEYPAD_FLG_POUND:

			key = UK_KEY_FLG_POUND;

			break;

		case UK_KEYPAD_FLG_SELECT:

			key = UK_KEY_FLG_SELECT;

			break;

		case UK_KEYPAD_FLG_UP:

			key = UK_KEY_FLG_UP;

			break;

		case UK_KEYPAD_FLG_RIGHT:

			key = UK_KEY_FLG_RIGHT;

			break;

		case UK_KEYPAD_FLG_DOWN:

			key = UK_KEY_FLG_DOWN;

			break;

		case UK_KEYPAD_FLG_LEFT:

			key = UK_KEY_FLG_LEFT;

			break;

		}

		if(type == Display.KEY_PRESSED_EVENT) {

			_keyFlags |= key;

			onKeyPress(key);

		}

		if(type == Display.KEY_RELEASED_EVENT) {

			if (param == Display.KEY_SOFT1) {

				onCommand(UK_COMMAND_SOFT1);

				return;

			}

			if (param == Display.KEY_SOFT2) {

				onCommand(UK_COMMAND_SOFT2);

				return;

			}

			_keyFlags &= ~key;

			onKeyRelease(key);

		}

	}

	protected void onKeyPress(int key) {

	}

	protected void onKeyRelease(int key) {

	}

	protected void onPaint(ukGraphics g) {

	}

	// ĕ`
	protected void update() {

		repaint();

	}

	public void paint(Graphics g) {

		_g.setGraphics(g);

		g.lock();

		onPaint(_g);

		g.unlock(true);

	}

}
