import com.nttdocomo.ui.*;

public class ukFont {

	private Font _font;
	private int _fontSize, _fontStyle;
	private int _height;

	static public final int FONTSIZE_SMALL = 0x0000;
	static public final int FONTSIZE_MEDIUM = 0x0001;
	static public final int FONTSIZE_LARGE = 0x0002;

	static public final int FONTSTYLE_NORMAL = 0x0000;
	static public final int FONTSTYLE_BOLD = 0x0100;

	/**
	* ftHgRXgN^
	*/
	public ukFont() {

		_fontSize = FONTSIZE_SMALL;
		_fontStyle = FONTSTYLE_NORMAL;

		_font = Font.getFont(Font.FACE_SYSTEM | Font.STYLE_PLAIN | Font.SIZE_TINY);

		_height = _font.getHeight();

	}

	/**
	* Rs[RXgN^
	*/
	public ukFont(ukFont f) {

		if (f == null) {

			_fontSize = FONTSIZE_SMALL;
			_fontStyle = FONTSTYLE_NORMAL;

			_font = Font.getFont(Font.FACE_SYSTEM | Font.STYLE_PLAIN | Font.SIZE_TINY);

			return;

		}

		_fontSize = f.getFontSize();
		_fontStyle = f.getFontStyle();

		if (f.getFont() != null) {
			parameterUpdate();
		}

	}

	/**
	* tHgTCY擾
	* @return tHgTCY
	*/
	public int getFontSize() {
		return _fontSize;
	}

	/**
	* tHgTCY擾
	* @param tHgTCY萔
	*/
	public void setFontSize(int size) {

		_fontSize = size;

		parameterUpdate();

	}

	/**
	* tHgX^C擾
	* @return tHgX^C
	*/
	public int getFontStyle() {
		return _fontStyle;
	}

	private void parameterUpdate() {

		int face = Font.FACE_SYSTEM;
		int style = Font.STYLE_PLAIN;
		int size = Font.SIZE_TINY;

		switch (_fontStyle) {

		case FONTSTYLE_BOLD:

			style = Font.STYLE_BOLD;

			break;

		default:

			_fontStyle = FONTSTYLE_NORMAL;

			break;

		}

		switch (_fontSize) {

		case FONTSIZE_MEDIUM:

			size = Font.SIZE_MEDIUM;

			break;

		case FONTSIZE_LARGE:

			size = Font.SIZE_LARGE;

			break;

		}

		_font = Font.getFont(face | style | size);

	}

	public int getHeight() {

		if (_font == null) {
			return 0;
		}

		return _height;

	}

	public int stringWidth(String str) {

		if (_font == null) {
			return 0;
		}

		return _font.stringWidth(str);

	}

	public Font getFont() {
		return _font;
	}

}
