import com.nttdocomo.ui.*;

/**
* vbgtH[̃lCeBuGraphicsbvOtBbNNX
*/
public class ukGraphics {

	private Graphics _g = null;

	private int _rgb;
	private int _defaultRGB;

	private ukFont _font;
	private ukFont _defaultFont;

	public static final int TOP = 1;
	public static final int BOTTOM = 2;
	public static final int RIGHT = 4;
	public static final int LEFT = 8;

	public static final int HCENTER = 16;
	public static final int VCENTER = 32;

	private int _offsetX, _offsetY;

	/**
	* ftHgRXgN^
	*/
	public ukGraphics() {

		_defaultFont = new ukFont();
		_font = _defaultFont;

		_defaultRGB = 0x00000000;
		_rgb = _defaultRGB;

		_offsetX = 0;
		_offsetY = 0;

	}

	/**
	* wlCeBuGraphicsukGraphicsIuWFNg쐬
	* param g lCeBuGraphicsCX^X
	*/
	public ukGraphics(Graphics g) {

		_defaultFont = new ukFont();
		_font = _defaultFont;

		_defaultRGB = 0x00000000;
		_rgb = _defaultRGB;

		setGraphics(g);

		_offsetX = 0;
		_offsetY = 0;

		reset();

	}

	/**
	* OtBbÑp[^
	*/
	public void reset() {

		setFont(_defaultFont);
		setRGB(_defaultRGB);

		_offsetX = 0;
		_offsetY = 0;

	}

	/**
	* wlCeBuGraphics𑀍Ώۂɐݒ
	* param g lCeBuGraphicsCX^X
	*/
	public void setGraphics(Graphics g) {

		_g = g;

		setFont(_font);

	}

	/**
	* ݂̃ItZbgXW擾
	* @return ݂̃ItZbgXW
	*/
	public int getOffsetX() {
		return _offsetX;
	}

	/**
	* ݂̃ItZbgYW擾
	* @return ݂̃ItZbgYW
	*/
	public int getOffsetY() {
		return _offsetY;
	}

	/**
	* ItZbgݒ
	* @param x ItZbgXW
	* @param y ItZbgYW
	*/
	public void setOffset(int x, int y) {

		_offsetX = x;
		_offsetY = y;

	}

	/**
	* `Fݒ
	* @param rgb RGBe8rbgRGBl
	*/
	public void setRGB(int rgb) {

		int r = (rgb & 0x00ff0000) >> 16;
		int g = (rgb & 0x0000ff00) >> 8;
		int b = rgb & 0x000000ff;

		setRGB(r, g, b);

	}

	/**
	* `Fݒ
	* @param r Ԑ
	* @param g ΐ
	* @param b 
	*/
	public void setRGB(int r, int g, int b) {

		_g.setColor(_g.getColorOfRGB(r, g, b));

		_rgb= (r << 16) | (g << 8) | b;

	}

	/**
	* ݂̃tHg擾
	* @return ݂̃tHg
	*/
	public ukFont getFont() {
		return _font;
	}

	/**
	* tHgݒ
	* @param f Vݒ肷tHg
	*/
	public void setFont(ukFont f) {

		_font = f;

		if (_g != null && _font != null) {
			_g.setFont(_font.getFont());
		}

	}

	/**
	* `
	* @param x1 Jn_XW
	* @param y1 Jn_YW
	* @param x2 I[_XW
	* @param y2 I[_YW
	*/
	public void drawLine(int x1, int y1, int x2, int y2) {

		if (_g == null) {
			return;
		}

		setRGB(_rgb);

		_g.drawLine(x1 + _offsetX, y1 + _offsetY, x2 + _offsetX, y2 + _offsetY);

	}

	/**
	* ``
	* @param x Jn_XW
	* @param y Jn_YW
	* @param width 
	* @param height 
	*/
	public void drawRect(int x, int y, int width, int height) {

		if (_g == null) {
			return;
		}

		setRGB(_rgb);

		_g.drawRect(x + _offsetX, y + _offsetY, width, height);

	}

	/**
	* hԂ``
	* @param x Jn_XW
	* @param y Jn_YW
	* @param width 
	* @param height 
	*/
	public void fillRect(int x, int y, int width, int height) {

		if (_g == null) {
			return;
		}

		setRGB(_rgb);

		_g.fillRect(x + _offsetX, y + _offsetY, width, height);

	}

	/**
	* hԂOp``
	* @param x1 _XW
	* @param y1 _YW
	* @param x2 _XW
	* @param y2 _YW
	* @param x3 O_XW
	* @param y3 O_YW
	*/
	public void fillTriangle(int x1, int y1, int x2, int y2, int x3, int y3) {

		if (_g != null) {

			int[] xs = {x1 + _offsetX, x2 + _offsetX, x3 + _offsetX};
			int[] ys = {y1 + _offsetY, y2 + _offsetY, y3 + _offsetY};

			_g.fillPolygon(xs, ys, 3);

		}

	}

	/**
	* 摜wʒuɕ`
	* @param img `悷摜
	* @param x `XW
	* @param y `YW
	*/
	public void drawImage(ukFixedImage img, int x, int y) {
		_g.drawImage(img.getImage(), x + _offsetX, y + _offsetY);
	}

	/**
	* 摜̈ꕔwʒuɕ`
	* @param img `悷摜
	* @param dx 摜]JnXW
	* @param dy 摜]JnYW
	* @param sx `XW
	* @param sy `YW
	* @param width `̈̉
	* @param height `̈̍
	*/
	public void drawImage(ukImage img, int dx, int dy, int sx, int sy, int width, int height) {

		_g.drawImage(img.getImage(), dx + _offsetX, dy + _offsetY, sx, sy, width, height);

	}

	/**
	* 摜̈ꕔwʒuɎwTCYŊgk`
	* @param img `悷摜
	* @param dx 摜]JnXW
	* @param dy 摜]JnYW
	* @param dwidth `̈̉
	* @param dheight `̈̍
	* @param sx 摜̕`JnXW
	* @param sy 摜̕`JnYW
	* @param swidth `悷摜̉
	* @param sheight `悷摜̍
	*/
	public void drawScaledImage(ukFixedImage img, int dx, int dy, int dwidth, int dheight, int sx, int sy, int swidth, int sheight) {

		if (_g == null || img == null || dwidth < 1 || dheight < 1 || swidth < 1 || sheight < 1 || sx < 0 || sy < 0 || sx >= img.getWidth() || sy >= img.getHeight()) {
			return;
		}

		_g.drawScaledImage(img.getImage(), dx + _offsetX, dy + _offsetY, dwidth, dheight, sx, sy, swidth, sheight);

	}

	/**
	* w蕶`悵̉擾
	* @param str `Ώە
	* @return `掞̉
	*/
	public int getStringWidth(String str) {

		if (str == null || str.length() < 1 || _font == null) {
			return 0;
		}

		return _font.stringWidth(str);

	}

	/**
	* w蕶`悵̍擾
	* @param str `Ώە
	* @return `掞̍
	*/
	public int getStringHeight(String str) {

		if (str == null || str.length() < 1 || _font == null) {
			return 0;
		}

		return _font.getHeight();

	}

	/**
	* `
	* @param str `悷镶
	* @param x `XW
	* @param y `YW
	*/
	public void drawString(String str, int x, int y) {

		if (_g == null || str == null) {
			return;
		}

		setFont(_font);

		y += _font.getHeight();

		_g.drawString(str, x + _offsetX, y + _offsetY);

	}

	/**
	* NbsÖݒ
	* @param x1 XW
	* @param y1 YW
	* @param width 
	* @param height 
	*/
	public void setClip(int x1, int y1, int width, int height) {

		if (_g == null) {
			return;
		}

		_g.setClip(x1, y1, width, height);

	}

	/**
	* lCeBuGraphics擾
	* @return Graphics
	*/
	public Graphics getGraphics() {
		return _g;
	}

}
