class ukURI {

	private String _uri, _path;
	private int _type;

	static public final int UK_URI_TYPE_NONE = 0;
	static public final int UK_URI_TYPE_HTTP = 1;
	static public final int UK_URI_TYPE_FILE = 2;

	public ukURI(String uri) {

		_path = null;
		_uri = null;

		_type = UK_URI_TYPE_NONE;

		if (uri == null || uri.length() < 1 || uri.equals("http://") || uri.equals("file://")) {
			return;
		}

		if (uri.indexOf("http://") == 0) {

			_uri = new String(uri);
			_path = new String(uri.substring(7));

			_type = UK_URI_TYPE_HTTP;

		}

		if (uri.indexOf("file://") == 0) {

			_uri = new String(uri);
			_path = new String(uri.substring(7));

			_type = UK_URI_TYPE_FILE;

		}

	}

	public ukURI(String path, int type) {

		if (path == null || path.length() < 1) {

			_path = null;
			_uri = null;

			_type = UK_URI_TYPE_NONE;

			return;

		}

		switch (type) {

		case UK_URI_TYPE_HTTP:

			_path = new String(path);

			if (path.indexOf("http://") == 0) {

				_path = _path.substring(7);
				_uri = new String(path);

			} else {
				_uri = "http://" + _path;
			}

			_type = type;

			break;

		case UK_URI_TYPE_FILE:

			_path = new String(path);

			if (path.indexOf("file://") == 0) {

				_path = _path.substring(7);
				_uri = new String(path);

			} else {
				_uri = "file://" + _path;
			}

			_type = type;

			break;

		}

	}

	public String getURI() {
		return _uri;
	}

	public String getPath() {
		return _path;
	}

	// pX̃fBNg擾
	public String getDirectory() {

		if (_path == null || _path.length() < 1) {
			return null;
		}

		int index = -1;

		for (int i = 0;i < _path.length();i++) {
			if (_path.charAt(i) == '/') {
				index = i;
			}
		}

		if (index < 1) {
			return null;
		}

		String dir = null;

		try {
			dir = _path.substring(0, index);
		} catch (Exception e) {
			dir = null;
		}

		return dir;

	}

	public int getType() {
		return _type;
	}

	public void setPath(String path) {

		if (path == null || path.length() < 1) {

			_path = null;
			_uri = null;

			return;

		}

		_path = new String(path);
		_uri = new String(path);

		switch (_type) {

		case UK_URI_TYPE_HTTP:

			_uri = "http://" + path;

			break;

		case UK_URI_TYPE_FILE:

			_uri = "file://" + path;

			break;

		}

	}

	public byte[] getData() {

		if (_uri == null) {
			return null;
		}

		switch (_type) {

		case UK_URI_TYPE_HTTP:

			return ukNetUtil.getHttpDocument(_uri);

		}

		return null;

	}

	public String toString() {
		return getURI();
	}

}
